val _= Hol_datatype ` Table_Val = TABLE_VAL of 'a | DONT_CARE `;

val MAP1 = Define
              `(MAP1 ([]:('a->'b) list) (t:'a)  = ([]:'b list)) /\
               (MAP1 ((x:'a->'b)::l) t = (x t) :: MAP1 l t)`; 

 val TableVal_to_Val = Define
`  (TableVal_to_Val (TABLE_VAL (v:'a)) = v)
`;

val  Table_match = Define
` (Table_match inputs []  = T) /\
       (Table_match inputs (CONS v vs)  =  
               (( (HD(inputs) ) =  (TableVal_to_Val (v:'a Table_Val) )) \/ (v = DONT_CARE)) /\ (Table_match (TL inputs) vs ) ) 
`;


 val table = Define `
      (table inps (out:num -> 'b) ([]:('a Table_Val list) list) u_out default t   = 
                   ( out t =  default t ))/\ 
       (table inps (out:num -> 'b) (vs:('a Table_Val list) list) [] default t          = 
                   (out t = default t ))/\ 
      (table inps  out            (CONS v vs)                 (CONS u u_out) default t  =          
                   ((Table_match (MAP1 inps t) v ) => (out t = u t )
                                          | (table inps out vs u_out default t )))`;


val  TABLE  = Define
` TABLE inps (out:num ->'b ) (V_outs:( 'a Table_Val list) list) V_out default = 
                (!t. table  inps out V_outs V_out default t ) `;


(*val  Table_match = Define
` (Table_match inputs [] (t:num) = T) /\
       (Table_match inputs (CONS v vs) t =  
               (( (HD(inputs) t) =  (TableVal_to_Val (v:'a Table_Val) )) \/ (v = DONT_CARE)) /\ (Table_match (TL inputs) vs t) ) 
`;

 val table = Define `
      (table inps (out:num -> Mdg_Basic) ([]:(Mdg_Basic Table_Val list) list) u_out default t   = 
                   ( (out t) =  (default t) ))/\ 
       (table inps (out:num -> Mdg_Basic) (vs:(Mdg_Basic Table_Val list) list) [] default t          = 
                   ( (out t) =  (default t) ))/\ 
      (table inps  out            (CONS v vs)                 (CONS u u_out) default t  =          
                   ((Table_match inps v t) => ( (out t) =  (u t) )
                                          | (table inps out vs u_out default t )))`;
*)

val SortCheck_Output = Define `SortCheck_Output out outval (t:num) = (IS_BOOL (outval t) => IS_BOOL (out t) | IS_CONCRETE (out t))`;



 val  SortCheck1 = Define
` (SortCheck1 (inputs:(num->Mdg_Basic) list) [] (t:num) = T) /\
  (SortCheck1 inputs (CONS v vs) t =  
               (( v = DONT_CARE) => T | (IS_BOOL  (TableVal_to_Val (v:Mdg_Basic Table_Val) )) => (IS_BOOL ((HD inputs) t)) |
                    (IS_CONCRETE   (TableVal_to_Val (v:Mdg_Basic Table_Val) )) => (IS_CONCRETE ((HD inputs) t))| T) /\ (SortCheck1 (TL inputs) vs t) ) 
`;



 val  SortCheck = Define
` (SortCheck (inputs:(num->Mdg_Basic) list) [] (t:num) = T) /\
  (SortCheck inputs (CONS v vs) t =  
               (SortCheck1 inputs v t) /\ (SortCheck ( inputs) vs t) ) 
`;

 val  TABLE  = Define
` TABLE inps (out:num ->Mdg_Basic ) (V_outs:( Mdg_Basic Table_Val list) list) V_out default = 
                (!t. ((SortCheck inps  V_outs t) /\ SortCheck_Output out (HD V_out) t /\ table  inps out V_outs V_out default t )) `;


 val  NEXT  = Define `NEXT (t:num) = (t+1) `;

val TSIG1 = Define `TSIG1 = \(t:num) .(BOOL T) `;

 val FSIG1 = Define `FSIG1 = \(t:num) .(BOOL F) `;

val NOT_TABLE = Define `NOT_TABLE x y  =
            TABLE [x] (( y):num-> Mdg_Basic ) [[TABLE_VAL (BOOL T)];[TABLE_VAL (BOOL F)]] [FSIG1;TSIG1] (\ (t:num). (ARB:Mdg_Basic))  `;


val AND_TABLE = new_definition("AND_TABLE",
   --`AND_TABLE x1 x2 y  =
            TABLE [( x1); x2] (( y):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]] 
                  [FSIG1;FSIG1;FSIG1;TSIG1] (\ (t:num). (ARB:Mdg_Basic)) `--) handle e => Raise e;

val REG_TABLE = Define `REG_TABLE  (x) (y:num->Mdg_Basic)  =
            TABLE [ x] (( y) o NEXT)  [[TABLE_VAL (BOOL T)];[TABLE_VAL (BOOL F)]] [TSIG1;FSIG1] (\ (t:num). (ARB:Mdg_Basic))  `;

val FORK_TABLE = Define `FORK_TABLE  (x) (y:num->Mdg_Basic)  =
            TABLE [ x] ( y )  [[TABLE_VAL (BOOL T)];[TABLE_VAL (BOOL F)]] [TSIG1;FSIG1]  (\ (t:num). (ARB:Mdg_Basic)) `;

 val OR_TABLE = Define `OR_TABLE x1 x2 y  =
            TABLE [ x1; x2] (y:num -> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]] 
             [FSIG1;TSIG1;TSIG1;TSIG1] (\ (t:num). (ARB:Mdg_Basic))  `;




val NAND_TABLE = new_definition("NAND_TABLE",
   --`NAND_TABLE x1 x2 (y:num-> Mdg_Basic) =
            TABLE [(x1);x2] ((y):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]] 
                  [TSIG1;TSIG1;TSIG1;FSIG1] (\ (t:num). (ARB:Mdg_Basic))  `--) handle e => Raise e;

val NOR_TABLE = new_definition("NOR_TABLE",
   --`NOR_TABLE x1 x2 (y:num-> Mdg_Basic) =
            TABLE [(x1);x2] ((y):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]] 
                  [TSIG1;FSIG1;FSIG1;FSIG1] (\ (t:num). (ARB:Mdg_Basic))  `--) handle e => Raise e;

val XOR_TABLE = new_definition("XOR_TABLE",
   --`XOR_TABLE x1 x2 y  =
            TABLE [(x1);x2] ((y):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]] 
                  [FSIG1;TSIG1;TSIG1;FSIG1] (\ (t:num). (ARB:Mdg_Basic))  `--) handle e => Raise e;

val JKFF_TABLE_new = new_definition("JKFF_TABLE_new",
   --`JKFF_TABLE_new j k Q =
            TABLE [(j); (k); (Q)] ((( Q) o NEXT):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1;TSIG1;FSIG1;FSIG1;FSIG1;TSIG1;TSIG1;FSIG1] 
                    (\ (t:num). (ARB:Mdg_Basic))  `--) handle e => Raise e;

val RSFF_TABLE= new_definition("RSFF_TABLE",
   --`RSFF_TABLE s1 r Q  =
            TABLE [(s1); (r); (Q)] (((Q) o NEXT):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); DONT_CARE];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); DONT_CARE];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)]]
                 [TSIG1;FSIG1;FSIG1;TSIG1] 
                 (((Q) o NEXT):num-> Mdg_Basic )    `--) handle e => Raise e;


val JKFF_ENABLE_TABLE = new_definition("JKFF_ENABLE_TABLE",
   --`JKFF_ENABLE_TABLE E j k (Q) = 
           TABLE [E;(j:num->Mdg_Basic); k; Q] ((Q) o NEXT)
                 [ [TABLE_VAL (BOOL F);DONT_CARE; DONT_CARE; TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL F);DONT_CARE; DONT_CARE; TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)]; 
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)]; 
                   [TABLE_VAL (BOOL T);TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]] 
                 [FSIG1;TSIG1;TSIG1;TSIG1;FSIG1;FSIG1;FSIG1;TSIG1;TSIG1;FSIG1] (\ (t:num).(ARB:Mdg_Basic)) `--);

val OR3_TABLE= new_definition("OR3_TABLE",
   --`OR3_TABLE x1 x2 x3 y =
            TABLE [(x1); (x2); (x3)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [FSIG1]  TSIG1`--) handle e => Raise e;

val OR4_TABLE= new_definition("OR4_TABLE",
   --`OR4_TABLE x1 x2 x3 x4 y  =
            TABLE [(x1); (x2); (x3); (x4)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [FSIG1]  TSIG1`--) handle e => Raise e;

 val OR5_TABLE= new_definition("OR5_TABLE",
   --`OR5_TABLE x1 x2 x3 x4 x5 y  =
            TABLE [(x1); (x2); (x3); (x4); (x5)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [FSIG1]  TSIG1  `--) handle e => Raise e;

 val OR6_TABLE= new_definition("OR6_TABLE",
   --`OR6_TABLE x1 x2 x3 x4 x5 x6 y  =
            TABLE [(x1); (x2); (x3); (x4); (x5); (x6)] ((( y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [FSIG1]  TSIG1  `--) handle e => Raise e;

val NOR3_TABLE= new_definition("NOR3_TABLE",
   --`NOR3_TABLE x1 x2 x3 y  =
            TABLE [(x1); (x2); (x3)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

val NOR4_TABLE= new_definition("NOR4_TABLE",
   --`NOR4_TABLE x1 x2 x3 x4 y  =
            TABLE [(x1); (x2); (x3); (x4)] ((( y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

 val NOR5_TABLE= new_definition("NOR5_TABLE",
   --`NOR5_TABLE x1 x2 x3 x4 x5 y =
            TABLE [(x1); (x2); (x3); (x4); (x5)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

 val NOR6_TABLE= new_definition("NOR6_TABLE",
   --`NOR6_TABLE x1 x2 x3 x4 x5 x6 y  =
            TABLE [(x1); (x2); (x3); (x4); (x5); (x6)] ((( y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;


val AND3_TABLE= new_definition("AND3_TABLE",
   --`AND3_TABLE x1 x2 x3 y  =
            TABLE [(x1); (x2); (x3)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

val AND4_TABLE= new_definition("AND4_TABLE",
   --`AND4_TABLE x1 x2 x3 x4 y =
            TABLE [(x1); (x2); (x3); (x4)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

 val AND5_TABLE= new_definition("AND5_TABLE",
   --`AND5_TABLE x1 x2 x3 x4 x5 y  =
            TABLE [(x1); (x2); (x3); (x4); (x5)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

 val AND6_TABLE= new_definition("AND6_TABLE",
   --`AND6_TABLE x1 x2 x3 x4 x5 x6 y  =
            TABLE [(x1); (x2); (x3); (x4); (x5); (x6)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1]  FSIG1  `--) handle e => Raise e;

val NAND3_TABLE= new_definition("NAND3_TABLE",
   --`NAND3_TABLE x1 x2 x3 y  =
            TABLE [(x1); (x2); (x3)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [FSIG1]  TSIG1  `--) handle e => Raise e;

val NAND4_TABLE= new_definition("NAND4_TABLE",
   --`NAND4_TABLE x1 x2 x3 x4 y  =
            TABLE [(x1); (x2); (x3); (x4)] ((( y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [FSIG1]  TSIG1  `--) handle e => Raise e;

 val NAND5_TABLE= new_definition("NAND5_TABLE",
   --`NAND5_TABLE x1 x2 x3 x4 x5 y  =
            TABLE [(x1); (x2); (x3); (x4); (x5)] ((( y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [FSIG1]  TSIG1  `--) handle e => Raise e;

 val NAND6_TABLE= new_definition("NAND6_TABLE",
   --`NAND6_TABLE x1 x2 x3 x4 x5 x6 y =
            TABLE [(x1); (x2); (x3); (x4); (x5); (x6)] (((y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [FSIG1]  TSIG1  `--) handle e => Raise e;


val JKFF_TABLE = new_definition("JKFF_TABLE",
   --`JKFF_TABLE x0 x1 y  =
            TABLE [(x0); (x1); (y)] (((y) o NEXT):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL F); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL F)];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1;TSIG1;FSIG1;FSIG1;FSIG1;TSIG1;TSIG1;FSIG1] 
                    (\ (t:num). (ARB:Mdg_Basic))  `--) handle e => Raise e;


val REGCON_TABLE = new_definition("REGCON_TABLE",
   --`REGCON_TABLE ctrl ip op  =
            TABLE [(ctrl); (ip); (op)] (((op) o NEXT):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); DONT_CARE];
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); DONT_CARE];
                   [TABLE_VAL (BOOL F); DONT_CARE; TABLE_VAL (BOOL T)];
                   [TABLE_VAL (BOOL F); DONT_CARE; TABLE_VAL (BOOL F)]]
                 [TSIG1;FSIG1;TSIG1;FSIG1] 
                    (\ (t:num). (ARB:Mdg_Basic))  `--) handle e => Raise e;



 
val CONST_TABLE = Define `CONST_TABLE (const:Mdg_Basic) op =
            TABLE [\ (t:num). const] (( op):num-> Mdg_Basic ) [[TABLE_VAL (BOOL T)];[TABLE_VAL (BOOL F)]] [TSIG1;FSIG1] (\ (t:num). (ARB:Mdg_Basic))  `;

val AO_TABLE= new_definition("AO_TABLE",
   --`AO_TABLE x1 x2 x3 x4 y =
            TABLE [(x1); (x2); (x3); (x4)] ((( y)):num-> Mdg_Basic ) 
                  [[TABLE_VAL (BOOL T); TABLE_VAL (BOOL T); DONT_CARE; DONT_CARE]; 
                   [TABLE_VAL (BOOL T); TABLE_VAL (BOOL F); TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)];
                    [TABLE_VAL (BOOL F); DONT_CARE; TABLE_VAL (BOOL T); TABLE_VAL (BOOL T)]]
                 [TSIG1; TSIG1; TSIG1]  FSIG1  `--) handle e => Raise e;
